HDU5727.Necklace-二分图匹配匈牙利

好久没写过博客了,把以前的博客补一下。

Necklace

Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 3603    Accepted Submission(s): 1097

Problem Description

SJX has 2*N magic gems. N of them have Yin energy inside while others have Yang energy. SJX wants to make a necklace with these magic gems for his beloved BHB. To avoid making the necklace too Yin or too Yang, he must place these magic gems Yin after Yang and Yang after Yin, which means two adjacent gems must have different kind of energy. But he finds that some gems with Yang energy will become somber adjacent with some of the Yin gems and impact the value of the neckless. After trying multiple times, he finds out M rules of the gems. He wants to have a most valuable neckless which means the somber gems must be as less as possible. So he wonders how many gems with Yang energy will become somber if he make the necklace in the best way.

Input

Multiple test cases.

For each test case, the first line contains two integers N(0≤N≤9),M(0≤M≤N?N), descripted as above.

Then M lines followed, every line contains two integers X,Y, indicates that magic gem X with Yang energy will become somber adjacent with the magic gem Ywith Yin energy.

Output

One line per case, an integer indicates that how many gem will become somber at least.

Sample Input

2 1

1 1

3 4

1 1

1 2

1 3

2 1

Sample Output

1

1

Author

HIT

Source

2016 Multi-University Training Contest 1

具体怎么写的忘记了

代码:

 1 #include <stdio.h>
 2 #include <math.h>
 3 #include <string.h>
 4 #include <stdlib.h>
 5 #include <iostream>
 6 #include <sstream>
 7 #include <algorithm>
 8 #include <string>
 9 #include <queue>
10 #include <ctime>
11 #include <vector>
12 using namespace std;
13 typedef long long ll;
14 const int INF=0x3f3f3f3f;
15 const int N=20;
16 int vis[N],a[N];
17 int n,m,ret;
18 int mp[N][N],g[N][N],match[N],used[N];
19 bool dfs(int u){
20     for(int v=1;v<=n;++v){
21         if(!g[u][v]||used[v])continue;
22         used[v]=true;
23         if(match[v]==-1||dfs(match[v])){
24             match[v]=u;
25             return true;
26         }
27     }
28     return false;
29 }
30 void solve(){
31     memset(match,-1,sizeof(match));
32     memset(g,0,sizeof(g));
33     for(int i=2;i<=n;++i){
34         for(int j=1;j<=n;++j){
35             if(mp[a[i]][j]||mp[a[i-1]][j])
36                 continue;
37             g[i][j]=true;//把珠子之间的关系做处理,褪色的两个珠子标记为0,不褪色的珠子为1,利用二分图最大匹配找到最大不消退数。
38         }
39     }
40     for(int i=1;i<=n;++i){
41         if(mp[a[1]][i]||mp[a[n]][i])
42             continue;
43         g[1][i]=true;
44     }
45     for(int i=1;i<=n;++i){
46         if(mp[a[1]][i]||mp[a[n]][i])
47             continue;
48         g[1][i]=true;
49     }
50     int ans=0;
51     for(int i=1;i<=n;++i){
52         memset(used,0,sizeof(used));
53         if(dfs(i))++ans;
54     }
55     ret=min(ret,n-ans);
56 }
57 void get(int x){
58     if(ret==0)return;
59     if(x==n+1){
60        solve();return;
61     }
62     for(int i=1;i<=n;i++){
63         if(vis[i])continue;
64         vis[i]=1;
65         a[x]=i;
66         get(x+1);
67         vis[i]=0;
68     }
69 }
70 int main(){
71     int v,u,i;
72     vis[1]=1;a[1]=1;
73     while(~scanf("%d%d",&n,&m)){
74         if(n==0){
75             printf("0\n");
76             continue;
77         }
78         memset(mp,0,sizeof(mp));
79         for(i=0;i<m;i++){
80             scanf("%d%d",&u,&v);
81             mp[v][u]=1;
82         }
83         ret=INF;
84         get(2);//n个阴珠子的全排列(注意:环形序列的全排列)
85         printf("%d\n",ret);
86     }
87     return 0;
88 }

原文地址:https://www.cnblogs.com/ZERO-/p/9113891.html

时间: 2024-11-19 06:42:31

HDU5727.Necklace-二分图匹配匈牙利的相关文章

USACO 4.2 The Perfect Stall(二分图匹配匈牙利算法)

The Perfect StallHal Burch Farmer John completed his new barn just last week, complete with all the latest milking technology. Unfortunately, due to engineering problems, all the stalls in the new barn are different. For the first week, Farmer John r

HDU 5943 Kingdom of Obsession 【二分图匹配 匈牙利算法】 (2016年中国大学生程序设计竞赛(杭州))

Kingdom of Obsession Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 49    Accepted Submission(s): 14 Problem Description There is a kindom of obsession, so people in this kingdom do things very

HDU1507 Uncle Tom&#39;s Inherited Land* 二分图匹配 匈牙利算法 黑白染色

原文链接http://www.cnblogs.com/zhouzhendong/p/8254062.html 题目传送门 - HDU1507 题意概括 有一个n*m的棋盘,有些点是废的. 现在让你用1*2的矩形覆盖所有的不废的点,并且不重叠,问最多可以覆盖多少个1*2的矩形,输出方案,有SPJ. 输入描述: 多组数据,每组首先两个数n,m(如果n和m为0,则结束程序) 然后给出k 然后给出k个二元组(x,y)表示废点的坐标. 题解 按照前两片博文的算法已经不行了,因为方案不对了. 所以我们要进行

矩阵游戏|ZJOI2007|BZOJ1059|codevs1433|luoguP1129|二分图匹配|匈牙利算法|Elena

1059: [ZJOI2007]矩阵游戏 Time Limit: 10 Sec  Memory Limit: 162 MB Description 小Q是一个非常聪明的孩子,除了国际象棋,他还很喜欢玩一个电脑益智游戏--矩阵游戏.矩阵游戏在一个N *N黑白方阵进行(如同国际象棋一般,只是颜色是随意的).每次可以对该矩阵进行两种操作:行交换操作:选择 矩阵的任意两行,交换这两行(即交换对应格子的颜色)列交换操作:选择矩阵的任意行列,交换这两列(即交换 对应格子的颜色)游戏的目标,即通过若干次操作,

网络流24题 第一题 - 洛谷2756 飞行员配对方案 二分图匹配 匈牙利算法

欢迎访问~原文出处--博客园-zhouzhendong 去博客园看该题解 题目传送门 题意概括 裸的二分图匹配 题解 匈牙利算法 上板子 代码 #include <cstring> #include <cstdio> #include <algorithm> #include <cstdlib> #include <cmath> using namespace std; const int N=100+5; int m,n,a,b,match[N

图论-二分图匹配-匈牙利算法

有关概念: 二分图:图G中的点集可以分为两个互不相交的子集,且G中的每条边连接的两个点分别属于这两个子集 二分图匹配:二分图G的子图M中每个结点上只连一条边,则称M为一个匹配 极大匹配:无法再向二分图中加边且满足匹配条件的匹配 最大匹配:所有极大匹配中边数最多的一个 增广路:若P为图G上连接两个未匹配结点的路径,且已匹配边和未匹配边在P上交替出现,则称P为相对于M的一条增广路 匈牙利算法即用来求二分图的极大匹配 思路: 在图G中找出增广路P,对P上每一条边取反(即已匹配边改为未匹配边,未匹配边改

#图# #二分图匹配# #匈牙利算法#

二分图 设G=(V,E)是一个无向图,如果顶点V可分割为两个互不相交的子集(A,B),并且图中的每条边(i,j)所关联的两个顶点i和j分别属于这两个不同的顶点集(i in A,j in B),则称图G为一个二分图. 区别二分图,关键是看点集是否能分成两个独立的点集. 二分图匹配(匈牙利算法) 最大匹配:设 是一个无向图.如顶点集V可分割为两个互不相交的子集 ,选择这样的子集中边数最大的子集称为图的最大匹配问题(maximal matching problem). 完全匹配:如果一个匹配中,  且

hdu 5727 Necklace 二分图匹配

题目链接 给2*n个珠子, n<=9, n个阴n个阳. 然后将它们弄成一个环, 阴阳交替.现在给你m个关系, 每个关系给出a, b. 如果阳a和阴b挨着, 那么a就会变暗. 问你最小变暗几个阳. 我们求出阴的所有全排列, 是9!, 因为形成一个环. 所以可以想象成一个珠子是固定不变的, 剩下n-1个变, 所以就是8!. 然后对于每种情况, 就是我们熟悉的二分图匹配了. 对于两个阴珠之间的空隙, 如果阳珠可以放到这里就连一条边. 然后跑匈牙利匹配就可以了. 9!过不了... #include <

BZOJ.3140.[HNOI2013]消毒(二分图匹配 匈牙利)

题目链接 不难想到每次一定是切一片. 如果是平面,很容易想到直接做二分图匹配.对于3维的? 可以发现min(a,b,c)的最大值只有\(\sqrt[3]{n}≈17\),我们暴力枚举这一最小值代表的是否选,对于剩下的两维二分图匹配 能用匈牙利用什么网络流啊..那么麻烦. 在匈牙利求解的过程中记得剪枝! 因为实际点数应该远不如ABC多,所以不要用memset,直接枚举. woc卡着时过去 那些2000ms怎么过的??网上找不到快点的懒得找. zz的我考场写的每次DFS完重建边+ISAP,成功都T掉

【二分图匹配/匈牙利算法】飞行员配对方案问题

P2756 飞行员配对方案问题 确认过眼神, 是二分图匹配板子题啦!!! 跑个匈牙利, 有匹配的输出, 记得先输出外籍飞行员, 因为有spj顺序无所谓啦qwq 最近A的最顺利的题了哈哈哈哈哈哈开心!!!!!!!! 1 #include<cstdio> 2 #include<cstring> 3 #include<iostream> 4 using namespace std; 5 const int sz = 100010; 6 int n, m, num = 0, a